unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan;

type
  TForm1 = class(TForm)
    Editor: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure EditorKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure CodeListClick(Sender: TObject);
  public
    { Public declarations }
    CodeList: TListBox;
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  CodeList := TListBox.Create(Self);
  CodeList.Parent := Editor;

  CodeList.Visible := False;
  CodeList.Width := 200;
  CodeList.Height := 100;
  CodeList.Items.Add('Caption');
  CodeList.Items.Add('Top');
  CodeList.Items.Add('Left');

  CodeList.OnDblClick := CodeListClick;
end;

procedure TForm1.CodeListClick(Sender: TObject);
var
  currentLine: Integer;
begin
  if CodeList.ItemIndex <> -1 then
  begin
    currentLine := Editor.CaretPos.Y;
    {       }
    Editor.Lines[currentLine] := Editor.Lines[currentLine] +
      CodeList.Items[CodeList.ItemIndex];
  end;
  CodeList.Visible := False;
  Editor.SetFocus;
end;

procedure TForm1.EditorKeyPress(Sender: TObject; var Key: Char);
var
  CliPos: TPoint;
  ListX: Integer;
  ListY: Integer;
begin
  if Key = '.' then
  begin
    {      }
    GetCaretPos(CliPos);

    {    }
    ListX := CliPos.X;
    ListY := CliPos.Y + CodeList.Canvas.TextHeight('W') + 4;

    if ListX + CodeList.Width >= Editor.Width then
      ListX := Editor.Width - CodeList.Width - 20;

    if ListY + CodeList.Height >= Editor.Height then
      ListY := Editor.Height - CodeList.Height - 20;

    CodeList.Top := ListY;
    CodeList.Left := ListX;
    CodeList.ItemIndex := 0;
    CodeList.Visible := True;
    CodeList.SetFocus;
  end else
    CodeList.Visible := False;
end;

end.
